unit RleCompression;
// code compression RLE

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Buttons, math, ExtDlgs, Spin, _Bibliotheque;

type
  //PixGrid = Array of Array of TColor;

  TCompression = Record		//Pour effectuer plusieurs compressions puis les comparer
                Horz,
                Vert,
                Affl,
                c2x2 : Boolean;
                end;

  TRLE =        Record
                Filename : String;                  //Le fichier temporaire de l'image sous forme de array of byte;
                Size, Height, Width, Colors : Integer;	    //Ses caractristiques
                Nature : Byte;			    //La compression (00 = FileError, 01 = RLEHorz, 02 = RLEVert, 03 = RLEAffl, 04 = ... (Until FE)..., FF = Bitmap Full //
                End;
                
  TForm1 = class(TForm)
    RGCompression: TGroupBox;
    StatusBar: TStatusBar;
    RGOptions: TGroupBox;
    CheckVert: TCheckBox;
    CheckHorz: TCheckBox;
    CheckAffl: TCheckBox;
    BtnCompress: TBitBtn;
    OPDialog: TOpenPictureDialog;
    CheckAuto: TCheckBox;
    GBOuvrirBMP: TGroupBox;
    BtnLoad: TButton;
    GBImgInfo: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LabelH: TLabel;
    LabelW: TLabel;
    LabelS: TLabel;
    Label4: TLabel;
    LabelC: TLabel;
    Label6: TLabel;
    LabelN: TLabel;
    GroupBox1: TGroupBox;
    LShowBMP: TStaticText;
    LShowDecompress: TStaticText;
    CheckBox1: TCheckBox;
    Label5: TLabel;
    SpinK: TSpinEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;

    Procedure ErrorMessage(Info : String);
    Function HexToInt(Val : String) : Integer;
    Function LoadBMP(Filename : String ; Var iecBmpH, iecBmpW, iecSize, iecNbC : Integer) : PixGrid;
    Function TRLEToFile(RLE : TRLE; Filename : String) : Boolean;
    Function MakeTRLE(Filename : String) : TRLE; 

    Function RLEHorz(PixImage : PixGrid) : TRLE;
    Function RLEVert(PixImage : PixGrid) : TRLE;
    Function ELRHorz(CompImage : TRLE) : PixGrid; //TBitMap;
    Function ELRVert(CompImage : TRLE) : PixGrid;

    procedure BtnLoadClick(Sender: TObject);
    {procedure CompressClick(Sender: TObject);}
    procedure BtnCompressClick(Sender: TObject);
    procedure LShowBMPClick(Sender: TObject);
    procedure LShowDecompressClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  iecBmpH, iecBmpW, iecSize, iecNbC : Integer;
  ImageEnCours: PixGrid;
  ActualCompression : TCompression;
  ByK : Byte = 2;

implementation

uses RleProgression, RleApercu, RleDecompression, RleVisualisation;

{$R *.DFM}


////////////////////////////////////////////////////////////////////////////////
/// ************************************************************************ ///
(* DEBUT----------------/ FONCTIONS DE COMPRESSION /--------------------DEBUT *)
/// ************************************************************************ ///
{RLEHorz                                                                      //
RLEVert                                                                       //
ELRHorz                                                                       //
ELRVert}                                                                      //
////////////////////////////////////////////////////////////////////////////////


///////////////
//DEBUT FONCTION RLEHorz
///////////////

Function TForm1.RLEHorz(PixImage : PixGrid) : TRLE;

Var i, j, k, m, s, ImgH, ImgW, lSize : Integer;
    PixColor : TColor;
    aFilename : String;

    Buffer, BufferT : Array[0 .. 3000] of Byte;
    BuffSize, BuffTSize : Integer;

    FileHandle : Integer;

begin

Randomize;
aFilename := 'c:\windows\temp\rlH' + IntToStr(Random(8999) + 1000) + '.tmp';
FileHandle := FileCreate(aFilename);
If FileHandle = (-1) then Begin Result.Nature := 00; ErrorMessage('RLE Horizontale : Cration du fichier de sortie teomporaire impossible'); Exit; End;

ImgH := iecBmpH;
ImgW := iecBmpW;

i := 0;                                                       //On remet a zro avant de commener
lSize := 0;

REPEAT                                                        //DBUT KOMPRESSION

j := 0;                                                       // Avant de commener une nouvelle ligne ...
k := 1;
BuffSize := 0;
BuffTSize := 2;                                               // ... on initialise les variables

If CheckAuto.Checked then Form2.PBarHorz.Position := ((i * imgH) DIV 100);              // Fac. (Not in DLL)

   Repeat
    PixColor := PixImage[j, i];
    While (j+k) <= (ImgW - 1) do
      If PixImage[j+k, i] = PixColor then Inc(k) else Break;
    //Original : If k < 3
    If k < ByK then For m := 0 to (k-1) do Begin BufferT[BuffTSize] := GetBValue(PixColor); BufferT[BuffTSize + 1] := GetGValue(PixColor); BufferT[BuffTSize + 2] := GetRValue(PixColor); Inc(BuffTSize, 3); End Else
       Begin
       If BuffTSize > 2 then Begin
                             BufferT[0] := 00;
                             BufferT[1] := ((BuffTSize - 2) DIV 3);
                             For m := 0 to (BuffTSize - 1) do Buffer[BuffSize + m] := BufferT[m];
                             Inc(BuffSize, BuffTSize);
                             BuffTSize := 2;
                             End;

       If (k <= 255) Then Begin
                          s := 0;
                          Buffer[BuffSize] := k;
                          End Else Begin
                                   s := 2;
                                   Buffer[BuffSize] := 01;
                                   Buffer[BuffSize + 1] := k;
                                   Buffer[BuffSize + 2] := (k DIV 256);
                                   End;


       Buffer[BuffSize + s + 1] := GetBValue(PixColor);
       Buffer[BuffSize + s + 2] := GetGValue(PixColor);
       Buffer[BuffSize + s + 3] := GetRValue(PixColor);
       Inc(BuffSize, s + 4);

       End;


   j := j + k;
   k := 1;

   Until ((j >= ImgW) and (BuffTSize > 2)) OR ((j >= (ImgW - 1)) and (BuffTSize <= 2));   // Attention : ne pas quitter le repeat avant un dernier tour. Sinon la dernire colonne reste vide (= peut quitter la ligne que si les derniers pixels sont les mmes. sinon fait un tour de plus)

   If BuffTSize > 2 then Begin								  // Si a fait le tour de plus (cf. commentaire 2 lignes plus haut), then enregistre les pixels ici.
                         BufferT[0] := 00;
                         BufferT[1] := ((BuffTSize - 2) DIV 3);
                         For m := 0 to (BuffTSize -1) do Buffer[BuffSize + m] := BufferT[m];
                         Inc(BuffSize, BuffTSize);
                         End;

   Inc(i);

   s := FileWrite(FileHandle, Buffer, BuffSize);
   If s <> BuffSize then ErrorMessage('#RLEHorz : Erreur d''criture dans ' + aFilename + '.' + #10#13 + 'Valeur envoye : ' + IntToStr(BuffSize) + '.' + #10#13 + 'Valeur retourne : ' + IntToStr(s) + '.');
   Inc(lSize, BuffSize);

UNTIL i = ImgH;                                          //FIN KOMPRESSION

FileClose(FileHandle);

Form2.PBarHorz.Position := 100;                           // Fac.

Result.Height := ImgH;                                   //Envoi des rsultats
Result.Width := ImgW;
Result.Nature := 1;                                   
Result.Size := lSize;
Result.Colors := 24;
Result.Filename := aFilename;

End;

///////////////
//FIN FONCTION RLEHorz
///////////////

///////////////
//DEBUT FONCTION RLEVert
///////////////

Function TForm1.RLEVert(PixImage : PixGrid) : TRLE;

Var i, j, k, m, s, ImgH, ImgW, lSize : Integer;
    PixColor : TColor;
    aFilename : String;

    Buffer, BufferT : Array[0 .. 3000] of Byte;
    BuffSize, BuffTSize : Integer;

    FileHandle : Integer;

begin

Randomize;
aFilename := 'c:\windows\temp\rlV' + IntToStr(Random(8999) + 1000) + '.tmp';
FileHandle := FileCreate(aFilename);
If FileHandle = (-1) then Begin Result.Nature := 00; ErrorMessage('#RLEVert : Cration du fichier de sortie temporaire impossible'); Exit; End;

ImgH := iecBmpH;
ImgW := iecBmpW;

j := 0;                                                       //On remet a zro avant de commener
lSize := 0;

REPEAT                                                        //DBUT KOMPRESSION

i := 0;                                                       // Avant de commener une nouvelle ligne ...
k := 1;
BuffSize := 0;
BuffTSize := 2;                                               // ... on initialise les variables

If not CheckAuto.Checked then Form2.PBarVert.Position := ((j * imgW) DIV 100);              //Fac. (Not in DLL)

   Repeat
    PixColor := PixImage[j, i];
    While (i+k) <= (ImgH - 1) do
      If PixImage[j, i+k] = PixColor then Inc(k) else Break;
    //Original : If k < 3
    If k < ByK then For m := 0 to (k-1) do Begin BufferT[BuffTSize] := GetBValue(PixColor); BufferT[BuffTSize + 1] := GetGValue(PixColor); BufferT[BuffTSize + 2] := GetRValue(PixColor); Inc(BuffTSize, 3); End Else
       Begin
       If BuffTSize > 2 then Begin
                             BufferT[0] := 00;
                             BufferT[1] := ((BuffTSize - 2) DIV 3);
                             For m := 0 to (BuffTSize - 1) do Buffer[BuffSize + m] := BufferT[m];
                             Inc(BuffSize, BuffTSize);
                             BuffTSize := 2;
                             End;

       If (k <= 255) Then Begin
                          s := 0;
                          Buffer[BuffSize] := k;
                          End Else Begin
                                   s := 2;
                                   Buffer[BuffSize] := 01;
                                   Buffer[BuffSize + 1] := k;
                                   Buffer[BuffSize + 2] := (k DIV 256);
                                   End;

       Buffer[BuffSize + s + 1] := GetBValue(PixColor);
       Buffer[BuffSize + s + 2] := GetGValue(PixColor);
       Buffer[BuffSize + s + 3] := GetRValue(PixColor);
       Inc(BuffSize, s + 4);

       End;


   i := i + k;
   k := 1;

   Until ((i >= ImgH) and (BuffTSize > 2)) OR ((i >= (ImgH - 1)) and (BuffTSize <= 2));   // Attention : ne pas quitter le repeat avant un dernier tour. Sinon la dernire colonne reste vide (= peut quitter la ligne que si les derniers pixels sont les mmes. sinon fait un tour de plus)

   If BuffTSize > 2 then Begin								  // Si a fait le tour de plus (cf. commentaire 2 lignes plus haut), then enregistre les pixels ici.
                         BufferT[0] := 00;
                         BufferT[1] := ((BuffTSize - 2) DIV 3);
                         For m := 0 to (BuffTSize -1) do Buffer[BuffSize + m] := BufferT[m];
                         Inc(BuffSize, BuffTSize);
                         End;

   Inc(j);


   s := FileWrite(FileHandle, Buffer, BuffSize);
   If s <> BuffSize then ErrorMessage('#RLEVert : Erreur d''criture dans ' + aFilename + '.' + #10#13 + 'Valeur envoye : ' + IntToStr(BuffSize) + '.' + #10#13 + 'Valeur retourne : ' + IntToStr(s) + '.');
   Inc(lSize, BuffSize);

UNTIL j = ImgW;                                          //FIN KOMPRESSION

FileClose(FileHandle);

Form2.PBarVert.Position := 100;                           // Fac.

Result.Height := ImgH;                                   //Envoi du rsultat
Result.Width := ImgW;
Result.Nature := 2;
Result.Size := lSize;
Result.Colors := 24;
Result.Filename := aFilename;

End;
///////////////
//FIN FONCTION RLEVert
///////////////

///////////////
//DEBUT FONCTION ELRHorz
///////////////
Function TForm1.ELRHorz(CompImage : TRLE) : PixGrid;

Label Fin;

Var ImgH, ImgW : Integer;

    FileHandle : Integer;
    Image : PixGrid;

    i, j, k, m, t, s : Integer;
    PixColor : TColor;

    Buffer : Array[0 .. 1999] of Byte;

begin

Form4.ProgressBar.Position := 0;     // Fac.

FileHandle := FileOpen(CompImage.Filename, 0);
FileOpen(CompImage.Filename, 0);

ImgH := CompImage.Height;
ImgW := CompImage.Width;

SetLength(Image, ImgW, ImgH);

i := 0; j := 0; k := 0; s := 0;

FileRead(FileHandle, Buffer, 2000);

REPEAT


If Buffer[k] = 0 then Begin
                      t := 0;
                      For m := 0 to (Buffer[k+1] - 1) do Begin
                                                         PixColor := Buffer[k+4] + Buffer[k+3] * 256 + Buffer[k+2] * 65536;
                                                         If (j+m) >= (ImgW) then Break;
                                                         Image[j + m, i] := PixColor;
                                                         Inc(k, 3);
                                                         Inc(t);
                                                         End;
                      Inc(j, t);
                      Inc(k, 2);
                      Goto fin;;
                      End;

If Buffer[k] <> 0 then Begin
                       If Buffer[k] = 1 then Begin
                                              PixColor := Buffer[k+5] + Buffer[k+4] * 256 + Buffer[k+3] * 65536;
                                              For m := 0 to (Buffer[k+1] + (Buffer[k+2] * 256) - 1) do Begin
                                                                                                       Image[j + m, i] := PixColor;
                                                                                                       End;
                                              Inc(j, Buffer[k+1] + (Buffer[k+2] * 256));
                                              Inc(k, 6);
                                              Goto fin;
                                              End Else Begin
                                                       PixColor := Buffer[k+3] + Buffer[k+2] * 256 + Buffer[k+1] * 65536;
                                                       For m := 0 to (Buffer[k] - 1) do Begin
                                                                                        Image[j + m, i] := PixColor;
                                                                                        End;
                                                       Inc(j, Buffer[k]);
                                                       Inc(k, 4);
                                                       Goto fin;
                                                       End;
                       End;

Fin:
If j >= (ImgW -1) then Begin
                       Inc(i);
                       j := 0;
                       Inc(s, k);
                       FileSeek(FileHandle, s, 0);
                       FileRead(FileHandle, Buffer, 2000);
                       k := 0;
                       End Else If (k > 1900) Then ErrorMessage('#ELRHorz : La variable K (' + IntToStr(k) + ') a atteint la limite de scurit du Buffer de dcompression (2000). Le systme pourrait signaler un tat critique dans les secondes suivantes.' +#10#13#10#13 + 'PS : Merci de corriger cette erreur avant une prochaine excution. Merci');

If (((100 * i) DIV ImgH) MOD 10) = 9 then Form4.ProgressBar.Position := ((100 * i) DIV ImgH);

UNTIL i = ImgH;

FileClose(FileHandle);

Result := Image;
iecBmpH := ImgH;
iecBmpW := ImgW;

end;

///////////////
//FIN FONCTION ELRHorz
///////////////

///////////////
//DEBUT FONCTION ELRVert
///////////////
Function TForm1.ELRVert(CompImage : TRLE) : PixGrid;

Label Fin;

Var ImgH, ImgW : Integer;

    FileHandle : Integer;
    Image : PixGrid;

    i, j, k, m, t, s : Integer;
    PixColor : TColor;

    Buffer : Array[0 .. 1999] of Byte;

begin

Form4.ProgressBar.Position := 0;     // Fac.

FileHandle := FileOpen(CompImage.Filename, 0);
FileOpen(CompImage.Filename, 0);

ImgH := CompImage.Height;
ImgW := CompImage.Width;

SetLength(Image, ImgW, ImgH);

i := 0; j := 0; k := 0; s := 0;

FileRead(FileHandle, Buffer, 2000);

REPEAT
If Buffer[k] = 0 then Begin
                      t := 0;
                      For m := 0 to (Buffer[k+1] - 1) do Begin
                                                         PixColor := Buffer[k+4] + Buffer[k+3] * 256 + Buffer[k+2] * 65536;
                                                         If (i+m) >= (ImgH) then Break;
                                                         Image[j, i + m] := PixColor;
                                                         Inc(k, 3);
                                                         Inc(t);
                                                         End;
                      Inc(i, t);
                      Inc(k, 2);
                      Goto Fin;
                      End;

If Buffer[k] <> 0 then Begin
                        If Buffer[k] = 1 then Begin
                                              PixColor := Buffer[k+5] + Buffer[k+4] * 256 + Buffer[k+3] * 65536;
                                              For m := 0 to (Buffer[k+1] + (Buffer[k+2] * 256) - 1) do Begin
                                                                                                       Image[j, i + m] := PixColor;
                                                                                                       End;
                                              Inc(i, Buffer[k+1] + (Buffer[k+2] * 256));
                                              Inc(k, 6);
                                              Goto fin;
                                              End Else Begin
                                                       PixColor := Buffer[k+3] + Buffer[k+2] * 256 + Buffer[k+1] * 65536;
                                                       For m := 0 to (Buffer[k] - 1) do Begin
                                                                                        Image[j, i + m] := PixColor;
                                                                                        End;
                                                       Inc(i, Buffer[k]);
                                                       Inc(k, 4);
                                                       Goto fin;
                                                       End;
                       End;
Fin:
If i >= (ImgH - 1) then Begin
                       Inc(j);
                       i := 0;
                       Inc(s, k);
                       FileSeek(FileHandle, s, 0);
                       FileRead(FileHandle, Buffer, 2000);
                       k := 0;
                       End Else If (k > 1900) Then ErrorMessage('#ELRVert : La variable K (' + IntToStr(k) + ') a atteint la limite de scurit du Buffer de dcompression (2000). Le systme pourrait signaler un tat critique dans les secondes suivantes.' +#10#13#10#13 + 'PS : Merci de corriger cette erreur avant une prochaine excution. Merci'); 

If (((100 * j) DIV ImgW) MOD 10) = 9 then Form4.ProgressBar.Position := ((100 * j) DIV ImgW);

UNTIL j = ImgW;

FileClose(FileHandle);

Result := Image;
iecBmpH := ImgH;
iecBmpW := ImgW;
iecNbC := 24;

end;

///////////////
//FIN FONCTION ELRVert
///////////////


////////////////////////////////////////////////////////////////////////////////
/// ************************************************************************ ///
(* FIN------------------/ FONCTIONS DE COMPRESSION /----------------------FIN *)
/// ************************************************************************ ///
////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////
/// ************************************************************************ ///
(* DEBUT------------------/ FONCTIONS IMPORTANTES /---------------------DEBUT *)
/// ************************************************************************ ///
{HexToInt                                                                     //
LoadBMP                                                                       //
ErrorMessage                                                                  //
TRLEToFile                                                                    //
MakeTRLE}                                                                     //
////////////////////////////////////////////////////////////////////////////////

///////////////
//DEBUT FONCTION HexToInt
///////////////


Function TForm1.HexToInt(Val : String) : Integer;
Var i : Integer;
    t1 : String;
Begin
Result := 0;
For i := 1 to Length(Val) do
    Begin
    t1 := UpperCase(Val[1]);
    If t1 = 'A' then t1 := '10'; If t1 = 'B' then t1 := '11'; If t1 = 'C' then t1 := '12'; If t1 = 'D' then t1 := '13'; If t1 = 'E' then t1 := '14'; If t1 = 'F' then t1 := '15';
    Result := Result + Trunc(StrToInt(t1) * Power(16, (Length(Val) - i) ) );
    End;

End;

///////////////
//DEBUT FONCTION LoadBMP
///////////////

Function TForm1.LoadBMP(Filename : String; Var iecBmpH, iecBmpW, iecSize, iecNbC : Integer) : PixGrid;

Var FileHandle, FileSize, ImgH, ImgW, i, j, k, DejaLu : Integer;
    BufferT : Array[0 .. 54] of Byte;
    Buffer : Array[0 .. 1022] of Byte;

Const Stop : Integer = 1023;

Begin

Result := Nil;
ImgH := 0;
ImgW := 0;

Try
 Begin
 FileHandle := FileOpen(Filename, 0);           //On ouvre le fichier
 FileSize := FileSeek(FileHandle, 0, 2);        (*}                         *)
 FileSeek(FileHandle, 0, 0);                    (*} On copie juste          *)
 FileRead(FileHandle, BufferT, 54);             (*}    l'entte             *)
 FileClose(FileHandle);                          // puis le referme.
 End;

If FileHandle = (-1) then Begin ErrorMessage('Le fichier est introuvable'); Exit; End;
If ((BufferT[0] <> Ord('B')) Or (BufferT[1] <> Ord('M'))) then Begin ErrorMessage('ErrorType #1 : Signature du fichier non valide'); Exit; End;
If FileSize <> ((BufferT[5] * 16777216) + (BufferT[4] * 65536) + (BufferT[3] * 256) + BufferT[2]) then Begin ErrorMessage('ErrorType #2 : Fin du fichier prcipite'); Exit; End;
If ((BufferT[6] <> 0) Or (BufferT[7] <> 0) Or (BufferT[8] <> 0) Or (BufferT[9] <> 0)) then Begin ErrorMessage('ErrorType #3 : Octets incorrects'); Exit; End;

{Buffer[ 10 and to 13] = BitMapOffset}              // On saute les 4 octets du dbut de l'image.
{Buffer[14 and to 17] = BitMapHeaderSize}          // on saute les 4 octets de la taille de l'en-tte.

Try Begin
ImgW := ((BufferT[21] * 16777216) + (BufferT[20] * 65536) + (BufferT[19] * 256) + BufferT[18]);
ImgH := ((BufferT[25] * 16777216) + (BufferT[24] * 65536) + (BufferT[23] * 256) + BufferT[22]); End; Except ErrorMessage('ErrorType #4 : Hauteur ou Largeur incorrecte(s)'); End;


If BufferT[26] <> 1 then Begin ErrorMessage('ErrorType #5 : Octet "BMP_Planes" incorrect'); Exit; End;

If ((BufferT[30]) + (BufferT[31] * 256) + (BufferT[32] * 65536) + (BufferT[33] * 1677216)) <> 00 then Begin ErrorMessage('ErrorType #6 : L''image est dja compresse'); Exit; End;

iecSize := FileSize;
iecNbC := BufferT[28];

Except; End;

SetLength(Result, ImgW, ImgH);
i := 0;
j := 0;

//
//Maintenant on attaque l'image.
//

FileHandle := 0;
Try
FileHandle := FileOpen(Filename, 0);
FileSeek(FileHandle, 54, 0);

Try                              // Commence a dessiner l'image dans le PixGrid
 Repeat
  DejaLu := FileRead(FileHandle, Buffer, Stop);
  For k := 1 to (DejaLu DIV 3) do
   Begin
    Try Result[j, (ImgH - i - 1)] := RGB(Buffer[((i * 3 * ImgW) + (3 * j) + 2) MOD Stop], Buffer[((i * 3 * ImgW) + (3 * j) + 1) MOD Stop], Buffer[((i * 3 * ImgW) + (3 * j) + 0) MOD Stop]);
    Except ErrorMessage('ErrorType #7 : Pixel incorrect : i = ' + IntToStr(i) + ' ; j = ' + IntToStr(j)); Result := Nil; Exit;  End;
    Inc(j);
    If j >= ImgW then Begin
                      j := 0;
                      Inc(i);
                      End;
    If i >= ImgH then Break;
   End;
 Until (DejaLu) <> Stop;
Except; ErrorMessage('ErrorType #8 : Dessin impossible'); End;

iecBmpH := ImgH; //Autres rsulats de la fonction
iecBmpW := ImgW;

Except ErrorMessage('ErrorType #9 : le traitement du fichier a chou'); End;
FileClose(FileHandle);

End;

///////////////
//DEBUT FONCTION ErrorMessage
///////////////

Procedure TForm1.ErrorMessage(Info : String);
Begin
MessageDLG(Info, mtError, [mbOk], 0);
End;


///////////////
//DEBUT FONCTION TRLEToFile
///////////////

Function TForm1.TRLEToFile(RLE : TRLE; Filename : String) : Boolean;
Var FileHandle, FileTMPHandle, i, Read : Integer;
    Buffer : Array[0 .. 6000] of Byte;
Begin
Result := True;
Try
FileHandle := FileCreate(Filename);

FileSeek(FileHandle, 0, 0);                    //Ajout de l'en-tte (Nb octets) :
FileWrite(FileHandle, 'RTPE', 4);                  // Signature (2)
FileWrite(FileHandle, RLE.Size, 3);                // Taille (3)
FileWrite(FileHandle, RLE.Width, 2);               //Largeur (2)
FileWrite(FileHandle, RLE.Height, 2);              //Hauteur (2)
FileWrite(FileHandle, RLE.Nature, 1);              //Nature (1)

// on crit maintenant l'image

FileTMPHandle := FileOpen(RLE.Filename, 0);
For i := 0 to (RLE.Size DIV 6001) do Begin
                                Read := FileRead(FileTMPHandle, Buffer, 6001);
                                FileWrite(FileHandle, Buffer, Read);
                                End;

FileClose(FileHandle);
FileClose(FileTMPHandle);                         // on ferme les fichiers.
Except Begin Result := False; ErrorMessage('Erreur dans la sauvegardedu fichier RTPE'); End;
End;

End;

///////////////
//DEBUT FONCTION MakeTRLE
///////////////

Function TForm1.MakeTRLE(Filename : String) : TRLE;
Var FileHandle, FileSize, NewHandle : Integer;
    BufferT : Array[0 .. 11] of Byte;
    Buffer : Array[0 .. 6000] of Byte;
    NewFile : String;
    i, Read : Integer;
    
Begin

FileHandle := 0;
FileSize := 0;
Result.Nature := 00;                     // Une nature de 00 dsigne un TRLE incorrect;

If FileExists(Filename) then
 Try
 Begin
 FileHandle := FileOpen(Filename, 0);
 FileSize := FileSeek(FileHandle, 0, 2);
 FileSeek(FileHandle, 0, 0);
 FileRead(FileHandle, BufferT, 12);
 End; Except ErrorMessage('#MakeTRLE : Le fichier est illisible'); Exit; End;



If ( (BufferT[0] <> Ord('R')) Or (BufferT[1] <> Ord('T')) Or (BufferT[2] <> Ord('P')) Or (BufferT[3] <> Ord('E')) ) then Begin ErrorMessage('#MakeTRLE : Le fichier n''est pas un fichier TPE.RLE correct'); Exit; End;

Result.Size := ((BufferT[6] * 65536) + (BufferT[5] * 256) + BufferT[4]);
Result.Width := ((BufferT[8] * 256) + (BufferT[7]));
Result.Height := ((BufferT[10] * 256) + (BufferT[9]));
Result.Nature := BufferT[11];
If (Result.Nature = 01) or (Result.Nature = 02) then Result.Colors := 24 else Result.Colors := 1;

If FileSize <> (Result.Size + 12) then Begin ErrorMessage('#MakeTRLE : Le fichier se termine prmaturment.' + #10#13 + 'Il ne sera donc pas ouvert'); Result.Nature := 00; Exit; End;

Randomize;
NewFile := 'c:\windows\temp\drlH' + IntToStr(Random(8999) + 1000) + '.tmp';
Result.Filename := NewFile;

NewHandle := FileCreate(NewFile);
If NewHandle = (-1) then Result.Nature := 00 else Begin
                         FileSeek(FileHandle, 12, 0);
                         For i := 0 to (Result.Size DIV 6001) do
                                Begin
                                Read := FileRead(FileHandle, Buffer, 6001);
                                FileWrite(NewHandle, Buffer, Read);
                                End;
                                                  End;
FileClose(FileHandle);
FileClose(NewHandle);
End;

////////////////////////////////////////////////////////////////////////////////
/// ************************************************************************ ///
(* FIN--------------------/ FONCTIONS IMPORTANTES /-----------------------FIN *)
/// ************************************************************************ ///
////////////////////////////////////////////////////////////////////////////////




procedure TForm1.BtnLoadClick(Sender: TObject);
begin
If OPDialog.Tag = 777 then Begin // Message reu du Ficher|Enregistrer sous
                           ChargerAllBMP2(OPDialog.FileName, iecBmpH, iecBmpW, iecSize, iecNbC, ImageEnCours);
                           StatusBar.Panels[0].text := OPDialog.Filename;
                           OPDialog.Tag := 0;
                           CheckHorz.Checked := True;
                           CheckVert.Checked := True;
                           SpinK.Value := 2;
                           CheckAuto.Checked := True;
                           BtnCompress.Click;
                           End ELSE

If OPDialog.Execute = False then Exit else Begin

                                           Try
                                            ChargerAllBMP2(OPDialog.FileName, iecBmpH, iecBmpW, iecSize, iecNbC, ImageEnCours); //ImageEnCours := LoadBMP(OPDialog.FileName, iecBmpH, iecBmpW, iecSize, iecNbC);
                                            Form3.ClientHeight := iecBmpH + 10;
                                            Form3.ClientWidth := iecBmpW + 10;
                                            If OPDialog.Tag <> 777 then Form3.Show else OPDialog.Tag := 0;
                                            Form3.Redessiner;
                                           Finally If ImageEnCours <> Nil then StatusBar.Panels[0].text := OPDialog.Filename; End;
                                          End;

If ImageEnCours <> Nil then Begin
LabelN.Caption := ExtractFileName(OPDialog.Filename);
LabelH.Caption := IntToStr(iecBmpH) + ' pix.';
LabelW.Caption := IntToStr(iecBmpW) + ' pix.';
LabelS.Caption := IntToStr(iecSize) + ' oct.';
LabelC.Caption := IntToStr(iecNbC) + ' bits';
BtnCompress.Enabled := True;
                            End;
end;

procedure TForm1.BtnCompressClick(Sender: TObject);
begin
ActualCompression.Horz := CheckHorz.Checked;
ActualCompression.Vert := CheckVert.Checked;
ActualCompression.Affl := CheckAffl.Checked;
ActualCompression.c2x2 := CheckAffl.Checked;
ByK := SpinK.Value;

Form2.ShowModal;
End;

procedure TForm1.LShowBMPClick(Sender: TObject);
begin
If ImageEnCours <> Nil then Begin Form3.Show;
                                  Form3.Redessiner;
                                  End Else MessageDLG('Vous n''avez ouvert encore aucune image', mtInformation, [mbOK], 0);
end;

procedure TForm1.LShowDecompressClick(Sender: TObject);
begin
Form4.Show;
end;

end.

