unit RleProgression;
// progression de l'ouverture / enregistrement (RLE)

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons;

type
  TForm2 = class(TForm)
    GBHorz: TGroupBox;
    GBVert: TGroupBox;
    GBAffl: TGroupBox;
    PBarHorz: TProgressBar;
    PBarVert: TProgressBar;
    PBarAffl: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    BtnHorzSave: TBitBtn;
    BtnVertSave: TBitBtn;
    BtnAfflSave: TBitBtn;
    LTpsHorz: TLabel;
    LTpsVert: TLabel;
    LTpsAffl: TLabel;
    LSizeHorz: TLabel;
    LSizeVert: TLabel;
    LSizeAffl: TLabel;
    LTauxHorz: TLabel;
    LTauxVert: TLabel;
    LTauxAffl: TLabel;
    LGainHorz: TLabel;
    LGainVert: TLabel;
    LGainAffl: TLabel;
    GroupBox1: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    LSourceHeight: TLabel;
    LSourceWidth: TLabel;
    LSourceColors: TLabel;
    LSourceSize: TLabel;
    BitBtn4: TBitBtn;
    SDialog: TSaveDialog;
    GBC2x2: TGroupBox;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    LTpsC2x2: TLabel;
    LSizeC2x2: TLabel;
    LTauxc2x2: TLabel;
    LGainC2x2: TLabel;
    ProgressBar1: TProgressBar;
    BtnC2x2Save: TBitBtn;

    Procedure ResetAll;
    Procedure BeginCompression;
    Procedure CalcTaux(SizeD, SizeA : Integer ; Var aTaux, aGain : String);
    Function GetInterval(Temps : TDateTime) : String;

    procedure FormShow(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BtnHorzSaveClick(Sender: TObject);
    procedure BtnVertSaveClick(Sender: TObject);
    procedure BtnAfflSaveClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form2: TForm2;
  aTaux, aGain : String;


implementation

uses RleCompression;

Var aRLEHorz, aRLEVert, aRLEAffl : TRLE;

{$R *.DFM}

procedure TForm2.FormShow(Sender: TObject);
begin

//ResetAll;
ResetAll;

//Check for Image Source Info
LSourceHeight.Caption := IntToStr(iecBmpH);
LSourceWidth.Caption := IntToStr(iecBmpW);
LSourceColors.Caption := IntToStr(iecNbC);
LSourceSize.Caption := IntToStr(iecSize);



// Check for what to do :
GBHorz.Enabled := ActualCompression.Horz;
GBVert.Enabled := ActualCompression.Vert;
GBAffl.Enabled := ActualCompression.Affl;
GBc2x2.Enabled := ActualCompression.c2x2;


If Form1.CheckAuto.Checked then BeginCompression;

end;

Function TForm2.GetInterval(Temps : TDateTime) : String;
Var Hour, Min, Sec, MSec : Word;
Begin
DecodeTime(Temps, Hour, Min, Sec, MSec);
Result := IntToStr(MSec + (Sec * 1000) + (Min * 60000) + (Hour * 60000 * 60));
End;

Procedure TForm2.CalcTaux(SizeD, SizeA : Integer ; Var aTaux, aGain : String);
Var QuoC : Real;
Begin
QuoC := 1 / (SizeD / SizeA);
aTaux := FormatFloat('#,###0.000', (100 * QuoC)) + ' %';
aGain := FormatFloat('#,###0.000', (100 * (1 - QuoC))) + ' %';
If Copy(aGain, 1, 1) = '-' then aGain := 'RLE inefficace';
End;

procedure TForm2.BitBtn4Click(Sender: TObject);
begin
ResetAll;

LSourceHeight.Caption := IntToStr(iecBmpH);
LSourceWidth.Caption := IntToStr(iecBmpW);
LSourceColors.Caption := IntToStr(iecNbC);
LSourceSize.Caption := IntToStr(iecSize);

BeginCompression;
end;

Procedure TForm2.BeginCompression;
Var Depart : TDateTime;
Begin
If ActualCompression.Horz then BEGIN
Depart := Now;
Try aRLEHorz := Form1.RLEHorz(ImageEnCours) Finally LTpsHorz.Caption := GetInterval(Now - Depart) + ' ms.'; End;
LSizeHorz.Caption := IntToStr(aRLEHorz.Size + 12) + ' octets';
CalcTaux(iecSize, aRLEHorz.Size + 12, aTaux, aGain);
LTauxHorz.Caption := aTaux;
LGainHorz.Caption := aGain;
                               END;

Application.ProcessMessages;

If ActualCompression.Vert then BEGIN
Depart := Now;
Try aRLEVert := Form1.RLEVert(ImageEnCours) Finally LTpsVert.Caption := GetInterval(Now - Depart) + ' ms.'; End;
LSizeVert.Caption := IntToStr(aRLEVert.Size + 12) + ' octets';
CalcTaux(iecSize, aRLEVert.Size + 12, aTaux, aGain);
LTauxVert.Caption := aTaux;
LGainVert.Caption := aGain;
                               END;

Application.ProcessMessages;

//RLEAffl := RLEAffl(ImageEnCours), 'c:\windows\temp\rleAffl.tmp');
End;

Procedure TForm2.ResetAll;
Begin
LSourceHeight.Caption  := '???';
LSourceWidth.Caption   := '???';
LSourceColors.Caption  := '???';
LSourceSize.Caption    := '???';
LSizeHorz.Caption      := '???';
LSizeVert.Caption      := '???';
LSizeAffl.Caption      := '???';
LTauxHorz.Caption      := '???';
LTauxVert.Caption      := '???';
LTauxAffl.Caption      := '???';
LGainHorz.Caption      := '???';
LGainVert.Caption      := '???';
LGainAffl.Caption      := '???';
LTpsHorz.Caption       := '???';
LTpsVert.Caption       := '???';
LTpsAffl.Caption       := '???';
PBarHorz.Position := 0;
PBarVert.Position := 0;
PBarAffl.Position := 0;
BtnHorzSave.Caption := 'Save';
BtnVertSave.Caption := 'Save';
BtnAfflSave.Caption := 'Save';
BtnC2x2Save.Caption := 'Save';
End;

procedure TForm2.BtnHorzSaveClick(Sender: TObject);
begin
If SDialog.Execute then Begin
                        If Copy(SDialog.Filename, Length(SDialog.Filename) - 4, 5) <> '.rtpe' then SDialog.Filename := SDialog.Filename + '.rtpe';
                        If Form1.TRLEToFile(aRLEHorz, SDialog.Filename) then BtnHorzSave.Caption := 'Succs' else BtnHorzSave.Caption := 'Erreur';
                        End;
end;

procedure TForm2.BtnVertSaveClick(Sender: TObject);
begin
If SDialog.Execute then Begin
                        If Copy(SDialog.Filename, Length(SDialog.Filename) - 4, 5) <> '.rtpe' then SDialog.Filename := SDialog.Filename + '.rtpe';
                        If Form1.TRLEToFile(aRLEVert, SDialog.Filename) then BtnVertSave.Caption := 'Succs' else BtnVertSave.Caption := 'Erreur';
                        End;
end;

procedure TForm2.BtnAfflSaveClick(Sender: TObject);
begin
If SDialog.Execute then Begin
                        If Copy(SDialog.Filename, Length(SDialog.Filename) - 4, 5) <> '.rtpe' then SDialog.Filename := SDialog.Filename + '.rtpe';
                        If Form1.TRLEToFile(aRLEAffl, SDialog.Filename) then BtnAfflSave.Caption := 'Succs' else BtnAfflSave.Caption := 'Erreur';
                        End;
end;

end.
   