Unit _WTPE;
// code LZW

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

Interface

Uses
	Windows, Graphics, SysUtils, Dialogs, Math, _Bibliotheque;

Procedure ErrorMessage(Info : String);

type
  ArrayOfByte = Array Of Byte; // Array[0 .. 1023] of Byte;

  dicLZW = Class
   Adresse, Codage : Integer;
   s, u : ArrayOfByte;
   SizS, SizU, Bts : Integer;

   Addaf : Array[0 .. 1] of Byte;
   Dico : Array[0 .. 8191] of Array of Byte;   // = 8192 lignes qui font toutes X cases.
   TailleDic : Integer; // 1024, 2048, 4096 ou 8192;

    Function CodeOf(s : ArrayOfByte ; SizS : Integer ; Count : Integer) : Word;
    Function SequenceOf(b : Word ; Count : Integer ; Var Size : Integer) : ArrayOfByte;
    Function IsInDicoS(U : ArrayOfByte ;  Count : Integer) : Boolean;
    Function CompileDicoS(i : Integer; l : Integer) : ArrayOfByte;
    Procedure AddDicoAS(Text : ArrayOfByte ; TextSizePos : Integer; Pos : Integer);

    Procedure Reset;
    Function Compare(A1, A2 : ArrayOfByte ; Length : Integer) : Boolean;

    Function FileComp(Filename, Filename2 : String ; Var CDC : CDCType ) : Integer;
    Function FileDeComp(Filename, Filename2 : String ; Var CDC : CDCType) : Integer;

   Function Compression(Var Texte : Array Of Byte ; TextSize : Integer ; FileHandle : Integer ; LastPass : Byte) : Integer;
   Function DeCompression(Var Texte : Array Of Byte ; TextSize: Integer ; FileHandle : Integer; LastPass : Byte) : Integer;
  End;

Implementation

uses uLZW;

Const
  dFilename : String = 'C:\WINDOWS\Profiles\JB\Bureau\TPE\Temp.txt';

var
         LZW : dicLZW;




//-- Fonction CODEOF - Cherche le code ( 260 + ) pour une chaine S

Function dicLZW.CodeOf(s : ArrayOfByte ; SizS : Integer ; Count : Integer) : Word;
Var i : Integer;
Begin
Result := 0;
If SizS = 1 then Begin
                 Result := s[0];
                 Exit;
                 End;

SetLength(s, SizS);

For i := (Count - 1) DownTo 0 do
                    If Compare(CompileDicoS(i, SizS), s, SizS) then Begin
                                                                    Result := (260 + i);
                                                                    Exit;
                                                                    End;

If Result = 0 then Result := s[0];

End;


//---- Fonction COMPARE - Compare 2 Array(s)OfByte

Function dicLZW.Compare(A1, A2 : ArrayOfByte ; Length : Integer) : Boolean;
Var i : Integer;
Begin
Result := True;

If SizeOf(A2) <> SizeOf(A1) then ErrorMessage('Problmes ! A1 <> A2');
If (A1 = Nil) then Begin
                   Result := False;
                   Exit;
                   End Else
For i := 0 to Length - 1 do
    If A1[i] <> A2[i] then Begin
                           Result := False;
                           Break;
                           End;
                           
End;


//-- Fonction ISINDICOS - Cherche si un string est prsent dans l'array DicoS.

Function dicLZW.IsInDicoS(U : ArrayOfByte ; Count : Integer) : Boolean;
Var i : Integer;
Begin
Result := False;
If Count = 0 then Exit;

For i := 0 to (Count - 1) do
                    If CompileDicoS(i, Length(U)) = U then Begin
                                                           Result := True;
                                                           Exit;
                                                           End;
End;

//-- Fonction SEQUENCEOF - Cherche la squence (string) pour un code

Function dicLZW.SequenceOf(b : Word ; Count : Integer ; Var Size : Integer) : ArrayOfByte;
Begin

If b < 256 then Begin
                Result[0] := b;
                SetLength(Result, 1);
                Size := 1;
                End

                Else

                Begin
                Result := CompileDicoS((b - 260), -1);
                Size := Length(Result);
                End;
End;


//-- Fonction COMPILEDICOS - Prends tous les Bytes et les colle dans le Result (String);

Function dicLZW.CompileDicoS(i : Integer ; l : Integer) : ArrayOfByte;
Var k, p : Integer;
Begin
If Length(LZW.Dico[i]) > 2 then p := LZW.Dico[i, 0];
If p = 0 then p := 1;
// LabelFF.                  
If (p <> l) and (l <> -1) then Begin Result := Nil; Exit; End;  // Divise par 5 le temps de compression
SetLength(Result, p); // Avant il tait en LabelFF. Donc mme si on allait s'en aller aprs, on resizait le rsultat, ce qui tait inutile.

For k := 0 to (p - 1) do Begin
                          Try Result[k] := LZW.Dico[i, k + 1]; Except ErrorMessage('Fonction COMPILEDICOS : Les rfrences linaires ne sont pas rsolues. Le fichier a peut-tre t mal compress.'); End;
                         End;
End;

//-- Fonction ADDDICOAS - Ajoute une chaine dans le dictionnaire;

Procedure dicLZW.AddDicoAS(Text : ArrayOfByte ; TextSizePos : Integer; Pos : Integer);
Var k : Integer;
Begin
If (Length(LZW.Dico[Pos]) < TextSizePos + 1) then SetLength(LZW.Dico[Pos], TextSizePos + 1); // Resize l'espace valeur ...
LZW.Dico[Pos, 0] := TextSizePos; // ... puis entre la taille de la valeur ...
For k := 1 to TextSizePos do LZW.Dico[Pos, k] := Text[k - 1]; // ... et enfin cette fameuse valeur.

End;

//-- Fonction COMPRESSION - Compression LZW.

Function dicLZW.Compression(Var Texte : Array Of Byte ; TextSize : Integer ; FileHandle : Integer ; LastPass : Byte) : Integer;

Var t : Byte; // Latent
    TempCode : Word; // Tout a pour viter le double "00" !
    TempCodeOld : Word; // Acclre ?
    Pos, Offset, TailleOct : Integer;
    Buffer : Array[0 .. 9000] of Byte;
    k : Integer;
    IsTempCode : Boolean;

Begin

Offset := 0;
Pos := 0;

If (LastPass = 0) or (LastPass = 254) then Begin
                                           LZW.s[0] := Texte[0];
                                           Inc(Pos, 1);
                                           LZW.SizS := 1;
                                           End;

If LZW.Addaf[0] <> 0 then                  Begin // rcupre les bits d'avant ...
                                           Offset := LZW.Addaf[0];
                                           Buffer[0] := LZW.Addaf[1];
                                           LZW.Addaf[0] := 0;
                                           End;

IsTempCode := False;

REPEAT
t := Ord(Texte[Pos]);

//For k := 0 to (LZW.SizS - 1) do LZW.u[k] := LZW.s[k];
LZW.u := LZW.s;
LZW.u[LZW.SizS] := t;                                  // d'o u := s + t
LZW.SizU := LZW.SizS + 1;

If (LZW.SizU >= (LZW.Bts - 4)) then Begin
                                    LZW.Bts := LZW.Bts * 2;
                                    SetLength(LZW.u, LZW.Bts);
                                    SetLength(LZW.s, LZW.Bts);
                                    End;


TempCode := CodeOf(LZW.u, LZW.SizU, LZW.Adresse - 260);


If (TempCode > 259) and (TempCode <> LZW.Adresse - 1) and (Pos <= TextSize - 1) then Begin

                                    //For k := 0 to (LZW.SizU - 1) do LZW.s[k] := LZW.u[k];
                                    LZW.s := LZW.u;
                                    LZW.SizS := LZW.SizU;
                                    TempCodeOld := TempCode;
                                    IsTempCode := True;
                                    Inc(Pos, 1);
                                    Continue;
                                    End

                                    Else

                                    Begin

                                    If (TempCode <> LZW.Adresse - 1) then AddDicoAS(LZW.u, LZW.SizU, LZW.Adresse - 260);

                                    If IsTempCode then EcrireBits(TempCodeOld, LZW.Codage, Offset, Buffer)
                                                  else EcrireBits(CodeOf(LZW.s, LZW.SizS, LZW.Adresse - 260), LZW.Codage, Offset, Buffer);
                                    IsTempCode := False;


                                    If LZW.Adresse >= (Power(2, LZW.Codage) - 1) then Begin
                                                                                      If LZW.Codage = Power(2, LZW.TailleDic) then Exit; // Car on va vider le dico dans la prochaine function
                                                                                      If CDC.Messages then fmLzw.ListBox1.Items.Add('Passage  ' + IntToStr(LZW.Codage + 1) + ' bits');
                                                                                      fmLzw.ListBox1.ItemIndex := fmLzw.ListBox1.Items.Count - 1;
                                                                                      fmLzw.ListBox1.Refresh;
                                                                                      EcrireBits(256, LZW.Codage, Offset, Buffer);
                                                                                      Inc(LZW.Codage, 1);
                                                                                      End;



                                    If (LZW.Adresse >= LZW.TailleDic) then Begin // En fait '=' doit suffire, mais '>=' pour on sait jamais (grrrrr)
                                                                          LZW.u[0] := t;
                                                                          LZW.SizU := 1; //Pour que t passe comme un arrayofbyte et non comme un simple byte;
                                                                          EcrireBits(CodeOf(LZW.u, 1, LZW.Adresse - 260), LZW.Codage, Offset, Buffer);
                                                                          EcrireBits(257, LZW.Codage, Offset, Buffer);
                                                                          LZW.Codage := 9;
                                                                          If CDC.Messages then fmLzw.ListBox1.Items.Add('Vidage du dictionnaire');
                                                                          fmLzw.ListBox1.ItemIndex := fmLzw.ListBox1.Items.Count - 1;
                                                                          fmLzw.ListBox1.Refresh;
                                                                          Reset;

                                                                          Inc(Pos, 1);
                                                                          t := Ord(Texte[Pos]);
                                                                          LZW.s[0] := t;
                                                                          LZW.SizS := 1;
                                                                          End


                                    Else Begin
                                         Inc(LZW.Adresse, 1); //En cas de triple "0", a fait une case vide dans le dico, mais c'est mieux qu'une case vide dans le fichier de sortie...
                                         Inc(Pos, 1);
                                         LZW.s[0] := t;
                                         LZW.SizS := 1;
                                         End; // B-E du Else qui se reproduit 8192 fois plus que le then.
                                    End;
UNTIL (Pos) = TextSize;


If (LastPass >= 254) and IsTempCode then EcrireBits(TempCodeOld, LZW.Codage, Offset, Buffer);

{If (LastPass >= 254) then Begin
                          LZW.u[0] := t;
                          LZW.SizU := 1; //Pour que t passe comme un arrayofbyte et non comme un simple byte;
                          EcrireBits(CodeOf(LZW.u, 1, LZW.Adresse - 260), LZW.Codage, Offset, Buffer);
                          End;} // MNoooooooooonnnnnn ! (alathieb) Ce fait 2 fois que tu tapes le mme code quis sert a rien !
                          // Alors ce commentaire tu l'effaces pas ! On avait bien dit que l t est dans le vide et t = 0 et il faut pas le prendre ?


TailleOct := (Offset DIV 8);

If ((Offset MOD 8) <> 0) then Begin // Y reste des bits.
                              If (LastPass >= 254) Then Inc(TailleOct, 1) // dernier passage car 254 (only one) ou 255 (lest one)
                              Else Begin
                                   LZW.Addaf[0] := Offset MOD 8;
                                   LZW.Addaf[1] := Buffer[TailleOct];
                                   End;
                              End;

//Inc(TailleOct, ()); // rajustage des octets  crire en fonction du fichier original (truandage, mais bon ...)                              

FileWrite(FileHandle, Buffer, TailleOct);

Result := TailleOct;
End;

//-- Fonction DECOMPRESSION - DCompression LZW.

Function dicLZW.DeCompression(Var Texte : Array Of Byte ; TextSize: Integer ; FileHandle : Integer; LastPass : Byte) : Integer;

Var a, b : Word;
    s0, Temp : ArrayOfByte;
    s : Array[0 .. 511] Of Byte;

    SizT, SizS, k, SizTotal : Integer;

    t : Byte;

    Offset : Integer;

    bDone : Boolean;

Begin

SizTotal := 0;
bDone := False;

t := 0;
Offset := 0;

       Begin
       SetLength(s0, 512);
       SetLength(Temp, 512);
       End;



If (LastPass = 0) or (LastPass = 254) then Begin
                                           a := LireBits(LZW.Codage, Offset, Texte);
                                           FileWrite(FileHandle, a, 1);
                                           End;


If LZW.Addaf[0] <> 0 then                  Begin // rcupre les bits d'avant ...  Explications en Fin
                                           b := LireBits(LZW.Codage - LZW.Addaf[0], Offset, Texte);
                                           b := b * Round(Power(2, LZW.Codage - LZW.Addaf[0]) + LZW.Addaf[1]);
                                           bDone := True;
                                           LZW.Addaf[0] := 0;
                                           End;





REPEAT

If not bDone then b := LireBits(LZW.Codage, Offset, Texte);

If b = 256 then Begin
                If CDC.Messages then fmLzw.ListBox1.Items.Add('Passage  ' + IntToStr(LZW.Codage + 1) + ' bits');
                fmLzw.ListBox1.ItemIndex := fmLzw.ListBox1.Items.Count - 1;
                fmLzw.ListBox1.Refresh;
                Inc(LZW.Codage, 1);
                Continue;
                End;

If b = 257 then Begin
                If CDC.Messages then fmLzw.ListBox1.Items.Add('Vidage du dictionnaire');
                fmLzw.ListBox1.ItemIndex := fmLzw.ListBox1.Items.Count - 1;
                fmLzw.ListBox1.Refresh;
                Reset;
                t := 0;
                a := LireBits(LZW.Codage, Offset, Texte);
                FileWrite(FileHandle, a, 1);
                Continue;
                End;

s0 := SequenceOf(b, LZW.Adresse - 260, SizS); // On regarde ce que l'on a pch dans "b". Peut tre ASCII ou DicoS(260+)

For k := 0 to SizS - 1 do s[k] := s0[k];  // Conversion de S0 en S pour faire un Buffer SizLimit pour ce con de FileWrate

FileWrite(FileHandle, s, SizS);
Inc(SizTotal, SizS);

Try t := s[0]; Except ErrorMessage('Erreur : Variable S vide.'); End; // le except ne doit JAMAIS se produire

Temp := SequenceOf(a, LZW.Adresse - 260 , SizT);
SetLength(Temp, SizT + 1);
Temp[SizT] := t;
Try AddDicoAS(Temp, (SizT + 1), (LZW.Adresse - 260)); Except ErrorMessage('ERREUR - Dcompression - Nouvelle entre dans le dictionnaire impossible'); End;
Inc(LZW.Adresse, 1);

a := b;

UNTIL Offset > (TextSize * 8) - LZW.Codage;

If (Offset <> TextSize * 8) then Begin // Y reste des bits.
                              If not (LastPass >= 254) Then
                                   Begin
                                   LZW.Addaf[0] := (TextSize * 8) - Offset;
                                   LZW.Addaf[1] := LireBits(LZW.Addaf[0], Offset, Texte);
                                   End;
                                 {Else RIEN ! Ainsi, on ne compte pas les 2 ou 3 bits qui ont permis de complter le dernier octet durant la compression !}  
                              End;

End;

// -- Procedure RESET;

Procedure dicLZW.Reset;
Var i : Integer;
Begin

LZW.Bts := 7;

SetLength(LZW.u, LZW.Bts);
SetLength(LZW.s, LZW.Bts);

For i := 0 to LZW.Bts do Begin
                         LZW.s[i] := 0;
                         LZW.u[i] := 0;
                         End;

For i := 0 to 8191 do SetLength(LZW.Dico[i], 63);
                         
LZW.Codage := 9;
LZW.Adresse := 260;
LZW.SizS := 0;
LZW.SizU := 0;
End;


//---- Fonction FILECOMP
Function dicLZW.FileComp(Filename, FileName2 : String ; Var CDC : CDCType) : Integer;

Var FileHandle, FileSize, SizeRead, FileHandleNew : Integer;
    Texte : Array[0 .. 8191] of Byte;
    LastPass : Byte;
    Size2, Passage : Integer;

Var Stop : Integer;

Begin
LZW := DicLZW.Create;

FileHandle := FileOpen(FileName, 0);
FileSize := FileSeek(FileHandle, 0, 2);
FileSeek(FileHandle, 0, 0);

FileHandleNew := FileCreate(FileName2);
FileWrite(FileHandleNew, 'WTPE', 4);
FileWrite(FileHandleNew, CDC.FileDico, 2);
FileWrite(FileHandleNew, '', 2);

(*Changement de l'entte :
0 - 3 : Signature : "WTPE"
4 - 5 : TailleDico : 4096, ou 8192
6 - 7 : 2 octets vide pour futur
8 - Fin : Fichier*)

Reset;
Size2 := 0;
Passage := 1;
LastPass := 0;
LZW.Addaf[0] := 0;
LZW.TailleDic := CDC.FileDico;

Stop := CDC.Packs;

CDC.StartTime := Now;

Repeat
SizeRead := FileRead(FileHandle, Texte, Stop);                            //D'o : LastPass vaut toujours 1, sauf :
If SizeRead <> Stop then If LastPass = 0
                         then LastPass := 254                             // "254" si le fichier < 4096 oct.
                         else LastPass := 255;                            // "0" si c'est le premier coup
If CDC.Messages then Begin fmLzw.ListBox1.Items.Add('Compression Paquet ' + IntToStr (Passage));
                           fmLzw.ListBox1.ItemIndex := fmLzw.ListBox1.Items.Count - 1;
                           fmLzw.ListBox1.Refresh;
                           fmLzw.ProgressBar1.Position := (Passage * 100) DIV ((FileSize DIV Stop) + 1);
                           fmLzw.ProgressBar1.Refresh;
                           End;
Inc(Passage);
Size2 := Size2 + Compression(Texte, SizeRead , FileHandleNew, LastPass);  // "255" si c'est le dernier
LastPass := 1;
Until Stop <> SizeRead;

CDC.EndTime := Now;

FileClose(FileHandle);
FileClose(FileHandleNew);

Result := ((FileSize - Size2) * 100) DIV FileSize;

LZW.Free // Libre mmoire;
End;



//---- Fonction FILE DE - COMP
Function dicLZW.FileDeComp(Filename, Filename2 : String ; Var CDC : CDCType) : Integer;

Var FileHandle, FileSize, SizeRead, FileHandleNew : Integer;
    Texte : Array[0 .. 8191] of Byte;
    LastPass : Byte;

    Test : Array[0 .. 3] of Byte;

    Size2, Passage : Integer;

Var Stop : Integer;

Begin
LZW := DicLZW.Create;

FileHandle := FileOpen(FileName, 0);
FileSize := FileSeek(FileHandle, 0, 2);
FileSeek(FileHandle, 0, 0);

FileRead(FileHandle, Test, 4);
If (Test[0] <> Ord('W')) or (Test[1] <> Ord('T')) or (Test[2] <> Ord('P')) or (Test[3] <> Ord('E')) then Begin
   ErrorMessage('Ceci n''est pas un fichier WTPE valide.'); CDC.EndTime := CDC.StartTime; Exit; End;

FileRead(FileHandle, LZW.TailleDic, 2);
FileSeek(FileHandle, 8, 0); // Se place au dbut du fichier compress.


FileHandleNew := FileCreate(Filename2);

Reset;
Size2 := 0;
Passage := 1;
LastPass := 0;
LZW.Addaf[0] := 0;

Stop := CDC.Packs;

CDC.StartTime := Now;

Repeat
SizeRead := FileRead(FileHandle, Texte, Stop);
If Stop <> SizeRead then If LastPass = 0
                         then LastPass := 254
                         else LastPass := 255;
If CDC.Messages then Begin fmLzw.ListBox1.Items.Add('Dcompression Paquet ' + IntToStr (Passage));
                           fmLzw.ListBox1.ItemIndex := fmLzw.ListBox1.Items.Count - 1;
                           fmLzw.ListBox1.Refresh;
                           fmLzw.ProgressBar1.Position := (Passage * 100) DIV ((FileSize DIV Stop) + 1);
                           fmLzw.ProgressBar1.Refresh;
                           End;
Inc(Passage);
Size2 := Size2 + DeCompression(Texte, SizeRead , FileHandleNew, LastPass);
LastPass := 1;
Until Stop <> SizeRead;

CDC.EndTime := Now;

FileClose(FileHandle);
FileClose(FileHandleNew);

Result := ((Size2 - FileSize) * 100) DIV FileSize;

LZW.Free // Libre mmoire;
End;


//-- Fonction ERRORMESSAGE

Procedure ErrorMessage(Info : String);
Begin
MessageDLG(Info, mtError, [mbOk], 0);
End;

{

Supposons qu'en fin on ne prenne pas 4 bits et que l'on soit en codage 9
Ils correspondent  1101.
On crit donc aprs le Until [4, 13] dans LZW.Addaf.

Au nouveau dpart, on va prendre 9 bits (LZW.Codage) - 4 bits (dja d'avant).
b := LireBits(LZW.Codage - LZW.Addaf[0], Offet, Texte);
b a donc pris 01100 (par exemple)

On les assemble ensuite : les 4 premiers [fois] 2^(nb qu'on en met aprs). + valeurDes5bitsD'aprs :

b := b * Power(2, LZW.Codage - LZW.Addaf[0]) + LZW.Addaf[1];



}
End.
